package hashmap

import (
	"474420502.top/eson/structure/lastack"
)

type nodePool struct {
	cache        *lastack.Stack
	data         []avlNode
	size         int
	growSize     int
	slimmingSize int
}

func newNodePool() *nodePool {
	p := &nodePool{}
	p.cache = lastack.New()
	p.data = make([]avlNode, 16, 16)
	p.countNextGrow()
	return p
}

func (pool *nodePool) Get() *avlNode {
	if !pool.cache.Empty() {
		v, _ := pool.cache.Pop()
		return v.(*avlNode)
	}
	pool.Grow()
	cur := &pool.data[pool.size]
	pool.size++
	return cur
}

func (pool *nodePool) Recycling(n *avlNode) {
	pool.cache.Push(n)
}

func (pool *nodePool) Grow() {
	if pool.size >= len(pool.data) {
		growsize := pool.size << 1
		temp := make([]avlNode, growsize, growsize)
		copy(temp, pool.data)
		pool.data = temp
		pool.countNextGrow()
	}
}

func (pool *nodePool) slimming() {
	if pool.size <= pool.slimmingSize {
		growsize := len(pool.data) - pool.slimmingSize<<1
		temp := make([]avlNode, growsize, growsize)
		copy(temp, pool.data)
		pool.data = temp
		pool.countNextGrow()
	}
}

func (pool *nodePool) countNextGrow() {
	pool.growSize = len(pool.data)
	pool.slimmingSize = pool.growSize << 1
}
